/**
 * TCS Dependency Map Renderer
 *
 * Copyright (c) 2005 TopCoder, Inc. All rights Reserved.
 */
package com.topcoder.rules.dependencymap.view.failuretests;

import junit.framework.TestCase;

import com.topcoder.rules.dependencymap.view.Dependency;

/**
 * Failure test cases for Dependency.
 *
 * @author TCSDeveloper
 */
public class DependencyTest extends TestCase {
    
    /**
     * Test constructor with null title.
     */
    public void testCon_Null() {
        try {
            new Dependency(null);
            fail("Should have thrown NullPointerException.");
        } catch (NullPointerException npe) { /* expected */ }
    }

    /**
     * Test constructor with null title.
     */
    public void testCon_Null2() {
        try {
            new Dependency(null, 123);
            fail("Should have thrown NullPointerException.");
        } catch (NullPointerException npe) { /* expected */ }
    }

    /**
     * Test constructor with null title.
     */
    public void testCon_Empty() {
        try {
            new Dependency("     ", 123);
            fail("Should have thrown IllegalArgumentException.");
        } catch (IllegalArgumentException npe) { /* expected */ }
    }

    public void testCon_Neg() {
        try {
            new Dependency("     ");
            fail("Should have thrown IllegalArgumentException.");
        } catch (IllegalArgumentException npe) { /* expected */ }
    }

    public void testCon_Inv() {
        try {
            new Dependency("greg", 0);
            fail("Should have thrown IllegalArgumentException.");
        } catch (IllegalArgumentException npe) { /* expected */ }
    }

    public void testCon_Silent() {
        try {
            new Dependency("greg", -1);
            
        } catch (Exception npe) { throw new RuntimeException("Should not have thrown Exception.", npe); }
    }
    
    /**
     * Test constructor with null title.
     */
    public void testSet_Null() {
        try {
            new Dependency("greg", 123).addDependant(null);
            fail("Should have thrown NullPointerException.");
        } catch (NullPointerException npe) { /* expected */ }
    }      
    
    /**
     * Test constructor with null title.
     */
    public void testSet_Silent() {
        new Dependency("greg", 123).addDependant(new Dependency("Greggy", -1));
    }
}
